# Copyright (C) 2003 Gregoire Lejeune <gregoire.lejeune@free.fr>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

module Asp
  class GlobalASA
    require 'asp/common'
    
    public
    def getAsaCode
      
#      secure = @xGAsaFile.taint
#      $SAFE=1
#      secure.untaint
#      @xGAsaFile.untaint
#      if File.exist?( @xGAsaFile ) == true
#        load( @xGAsaFile )
#        return true
#      else
#        return false
#      end



#      tmpdir = Asp::Common::stateDir
      code = IO::readlines( @xGAsaFile ).join( " " )
      
#      file = Tempfile.new(File.basename(@xGAsaFile) + ".", tmpdir)
      filename = @xGAsaFile
      begin
		@oAspHandler.load_code( code, filename )
      
#        file.print(code)
#        file.close
#        file.untaint
#        load(file.path.untaint).untaint
      rescue => e
        if Asp::Common::debug == 1 
          result = @oApacheRequest.escape_html(e.message)
          @oApacheRequest.server.log_error( "[Ruby/ASP] [%d] : (%s) : %s", $$, __FILE__, result )
        end
        return false
#      ensure
#        file.close(true)
      end

      return true 
  
    end
    
    private 
    def initialize( xFile, r, aspHandler )
      @oApacheRequest = r
      @xGAsaFile = mapPath( xFile + "/global.asa" )
      @xGAsaFile.untaint
	  @oAspHandler = aspHandler
    end
  
    def mapPath( path )
      result = ( @oApacheRequest.lookup_file( path ).filename || path )
      return result
    end

  end
end
